<?php
    /*------------------------------------------------------------------------
	# mod_sp_stock - Yahoo stock module by JoomShaper.com
	# ------------------------------------------------------------------------
	# author    JoomShaper http://www.joomshaper.com
	# Copyright (C) 2010 - 2012 JoomShaper.com. All Rights Reserved.
	# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
	# Websites: http://www.joomshaper.com
    -------------------------------------------------------------------------*/

    // no direct access
    defined('_JEXEC') or die('Restricted access');

    /**
    * 
    */
  

    class Mod_SP_Stock
    {	
        private $config;
        private $raw_data;
        private $raw_url;
        private $base_url = 'http://chart.finance.yahoo.com/z?';
        private $symbols = array();

        //Initiate configurations
        public function __construct($params) {
            $this->raw_url = $this->generateURL($params);
            array_push($this->symbols,'"'.$params->get('stock_id').'"');

            if( $params->get('comparing_ids')!='' ) {
                $z = explode(',',$params->get('comparing_ids'));
                foreach($z as $v) array_push($this->symbols,'"'.trim($v).'"');
            }

            return $this;
        }

        private function generateURL($params)
        {
            $p = array();
            $qs = '&amp;p=';

            if( $params->get('moving_average_indicator')!='' )
            {
                $p = explode(',',$params->get('moving_average_indicator'));
                foreach($p as $v) $k[] = 'm'.trim($v);

                $qs .= implode(',',$k);
            }

            if( $params->get('exponential_moving_average_indicator')!='' )
            {
                $p = explode(',',$params->get('exponential_moving_average_indicator'));
                foreach($p as $v) $t[] = 'e'.trim($v);

                $qs .= implode(',',$t);
            }

            if( is_array($params->get('technical_indicator')) )
            {

                $qs .= implode(',', $params->get('technical_indicator') );
            }

            if( $params->get('comparing_ids')!='' )
            {
                $z = explode(',',$params->get('comparing_ids'));
                foreach($z as $v) $c[] = trim($v);
                $qs .= '&amp;c='.implode(',',$c);
            }

            $urls = array(
                's'=>$params->get('stock_id'),
                't'=>$params->get('time_span'),
                'q'=>$params->get('chart_type'),
                'l'=>$params->get('chart_scale'),
                'z'=>$params->get('chart_image_size')
            );

            $url = http_build_query($urls,'', '&amp;');
            $url .= $qs;
            return $url;
        }


        public function getChart() {
            return $this->base_url.$this->raw_url;
        }

        public function getQuote()
        {
            $url  = 'http://query.yahooapis.com/v1/public/yql?q=';
            $trail = ('&format=json&diagnostics=true&env=http%3A%2F%2Fdatatables.org%2Falltables.env');
            $YQLquery = rawurlencode(sprintf('select * from yahoo.finance.quotes where symbol in (%s)', implode(',',$this->symbols) ));
            $url = $url.$YQLquery.$trail;
            // create a new cURL resource
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($curl, CURLOPT_TIMEOUT, 30);
            curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
            $data = curl_exec($curl);
            curl_close($curl);
            return json_decode($data,true);
        }
    }
